<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="com.zipdoc.acs.persistence.dao.CommentDao">

	<resultMap id="commentResult" type="Comment">
		<id property="reply_no" column="REPLY_NO" />
		<result property="cno" column="CNO"/>
		<result property="parent_reply_no" column="PARENT_REPLY_NO"/>
		<result property="contents" column="CONTENTS"/>
		<result property="reply_flag" column="REPLY_FLAG"/>
		<result property="expose" column="EXPOSE"/>
		<result property="deleted_flag" column="DELETED_FLAG"/>
		<result property="creater" column="CREATER"/>
		<result property="create_date" column="CREATE_DATE"/>
		<association property="profile" javaType="Profile" >
			<id property="member_no" column="MEMBER_NO"/>
			<result property="nickname" column="NICKNAME"/>
			<result property="profile_url" column="PROFILE_URL"/>
		</association>
	</resultMap>

	<select id="selectListTotalCount" parameterType="com.zipdoc.acs.model.CommentListRequest" resultType="int">
		SELECT COUNT(*)
		FROM ${table_name} P, T_MEMBER M
		WHERE P.CNO = #{cno}
		AND P.CREATER = M.MEMBER_NO
	</select>

	<select id="selectList" parameterType="com.zipdoc.acs.model.CommentListRequest" resultMap="commentResult">
		SELECT
			 P.REPLY_NO
			,P.CNO
			,P.PARENT_REPLY_NO
			,P.CONTENTS
			,P.REPLY_FLAG
			,P.EXPOSE
			,P.DELETED_FLAG
			,P.CREATER
			,P.CREATE_DATE
			,P.CREATER AS MEMBER_NO
			,M.NICKNAME AS NICKNAME
			,M.PROFILE_URL AS PROFILE_URL
		FROM ${table_name} P, T_MEMBER M
		WHERE P.CNO = #{cno}
		  AND P.CREATER = M.MEMBER_NO
		<if test="sort != null and sort == 1">
			ORDER BY P.REPLY_NO DESC
		</if>
		<if test="sort != null and sort == 2">
			ORDER BY P.REPLY_NO ASC
		</if>
		LIMIT #{startRow}, #{limit}
	</select>

	<select id="selectById" parameterType="Comment" resultType="Comment">
		SELECT
		 P.REPLY_NO
		,P.CNO
		,P.PARENT_REPLY_NO
		,P.CONTENTS
		,P.REPLY_FLAG
		,P.EXPOSE
		,P.DELETED_FLAG
		,P.CREATER
		,P.CREATE_DATE
		FROM ${table_name} P
		WHERE P.REPLY_NO = #{reply_no}
		LIMIT 1
	</select>


	<select id="selectNextReplyNo" parameterType="Comment" resultType="int">
		SELECT IFNULL((SELECT MAX(REPLY_NO) FROM ${table_name}), 0) + 1
		FROM DUAL
	</select>

	<insert id="insert" parameterType="Comment">
		INSERT INTO ${table_name}(
		 REPLY_NO
		,CNO
		,PARENT_REPLY_NO
		,CONTENTS
		,REPLY_FLAG
		,EXPOSE
		,DELETED_FLAG
		,IP
		,CREATE_DATE
		,CREATER
		)
		VALUES (
		 #{reply_no}
		,#{cno}
		,#{parent_reply_no}
		,#{contents}
		,#{reply_flag}
		,#{expose}
		,#{deleted_flag}
		,#{ip}
		,now()
		,#{creater}
		)
	</insert>

	<update id="update" parameterType="Comment">
		UPDATE ${table_name}
		SET
		 CONTENTS = #{contents}
		,EXPOSE = #{expose}
		,UPDATE_DATE = NOW()
		,UPDATER = #{updater}
		WHERE
		REPLY_NO = #{reply_no}
	</update>

	<update id="updateDeleteFlag" parameterType="Comment">
		UPDATE ${table_name}
			SET
			 DELETED_FLAG = 1
			,CONTENTS = #{contents}
			,UPDATE_DATE = NOW()
			,UPDATER = #{updater}
		WHERE
		REPLY_NO = #{reply_no}
	</update>

	<delete id="delete" parameterType="Comment">
		DELETE FROM ${table_name}
		 WHERE REPLY_NO = #{reply_no}
		    OR PARENT_REPLY_NO = #{reply_no}
	</delete>


</mapper>